<?php

/*
 * Plugin Name: Basisklassifikation
 * Version: 0.1.0
 * Description: Provides the <a href='https://wiki.k10plus.de/display/K10PLUS/Basisklassifikation'>Basisklassifikation</a> taxonomy.
 * Author: Odin Kroeger
 * Author URI: mailto:odin.kroeger@univie.ac.at
 * Requires PHP: 8.2
 * Text Domain: basisklassifikation
 * Domain Path: /lang
 */

/*
 * Boilerplate
 */

declare(strict_types=1);

namespace Univie\Basisklassifikation;

if (!defined('\\ABSPATH')) {
    exit();
}


/*
 * Constants
 */

/* Base directory of the plugin. */
define(__NAMESPACE__ . '\\BASE_DIR', plugin_dir_path(__FILE__));

/* Base URL of the plugin. */
define(__NAMESPACE__ . '\\BASE_URL', plugin_dir_url(__FILE__));

/* Plugin file. */
define(__NAMESPACE__ . '\\PLUGIN_FILE', plugin_basename(__FILE__));

/* Base directory for PHP modules. */
const PHP_DIR = BASE_DIR . 'php' . DIRECTORY_SEPARATOR;

/* Directory to load other PHP files from. */
const INCLUDE_DIR = PHP_DIR . 'includes' . DIRECTORY_SEPARATOR;

/* Directory for templates. */
const TEMPLATE_DIR = INCLUDE_DIR . 'templates' . DIRECTORY_SEPARATOR;

/* Directory to auto-load classes from. */
const CLASS_DIR = PHP_DIR . 'classes';

/* Taxonomy name. */
const TAXONOMY = 'basisklassifikation';

/* Maximum execution time in seconds. */
const MAX_EXECUTION_TIME = 1800;


/*
 * Modules
 */

require INCLUDE_DIR . 'autoloader.php';
require INCLUDE_DIR . 'plugin.php';


/*
 * Main
 */

Autoloader\register(namespace: __NAMESPACE__, basedir: CLASS_DIR);

register_activation_hook(__FILE__, __NAMESPACE__ . '\\Plugin\\activate');

add_action('init', __NAMESPACE__ . '\\Plugin\\init', 5000);
